{ define DEBUG_HELPER}
{$ifdef DEBUG_HELPER}
  {$include DebugHelper.lib.pas}
{$endif}

function GetMyDir:string;
begin
  Result:=RegExSubstitute('(.*)(\\.*?)$',GEOGET_SCRIPTFULLNAME,'$1');
end;

function GetMyName:string;
begin
  Result:=RegExSubstitute('(.*\\)(.*?)\.ggi\.pas$',GEOGET_SCRIPTFULLNAME,'$2');
end;

function GetPluginDir:string;
begin
  Result:=GEOGET_DATADIR+'\ggmap\plugin';
end;

function GetIniDir:string;
begin
  Result:=GEOGET_SCRIPTDIR+'\ggmap\'+GetMyName();
end;

procedure MoveFilesByExt(sMask:string);
var aList:TStringList;
    sName:string;
    i,j:integer;
begin
  //kopiruje soubory se zadanou priponou do adresare pluginu GgMapy
  aList:=TStringList.Create();
  try
    FileList(GetIniDir(),aList);
    for i:=0 to aList.Count-1 do begin
      j:=Pos(sMask,aList[i])-1;
      sName:=RegExSubstitute('(.*\\)(.*)$',aList[i],'$2');
      //pokud je to maska na konci, kopirujeme soubor
      if(j+Length(sMask)=Length(aList[i])) then begin
        CopyFile(aList[i],GetPluginDir()+'\'+sName);
        DeleteFile(aList[i]); //to je zbytecne, kdyz se na konci maze cely adresar
      end;
    end;
  finally
    aList.Free();
  end;
end;

function InstallWork: String;
var s1,s2:string;
begin
{$ifdef DEBUG_HELPER} LDHInit(true); {$endif}
  Result:='';
  {$ifdef DEBUG_HELPER} LDH('MyName='+GetMyName()); {$endif}
  {$ifdef DEBUG_HELPER} LDH('MyDir='+GetMyDir()); {$endif}
  {$ifdef DEBUG_HELPER} LDH('IniDir='+GetIniDir()); {$endif}
  {$ifdef DEBUG_HELPER} LDH('PluginDir='+GetPluginDir()); {$endif}
  //meta.ini a ggi.pas preneseme do spravneho adresare
  ForceDirectories(GetIniDir());
  s1:=GetMyDir()+'\'+GetMyName()+'.meta.ini'; s2:=GetIniDir()+'\..\'+GetMyName()+'.meta.ini';
  {$ifdef DEBUG_HELPER} LDH('Test file: '+s2); {$endif}
  if(FileExists(s2)) then DeleteFile(s2); //bez smazani se neprekopiruje nova verze
  {$ifdef DEBUG_HELPER} LDH('Move: '+s1+' ==> '+s2); {$endif}
  RenameFile(s1,s2);
  s1:=GetMyDir()+'\'+GetMyName()+'.ggi.pas'; s2:=GetIniDir()+'\..\'+GetMyName()+'.ggi.pas';
  {$ifdef DEBUG_HELPER} LDH('Test file: '+s2); {$endif}
  if(FileExists(s2)) then DeleteFile(s2); //bez smazani se neprekopiruje nova verze
  {$ifdef DEBUG_HELPER} LDH('Move: '+s1+' ==> '+s2); {$endif}
  RenameFile(s1,s2);
  //soubory *.js a *.css preneseme do adresare pro mapove pluginy
  MoveFilesByExt('.ggm.js');
  MoveFilesByExt('.css');
  //mohl tu zustat adresar <JmenoPluginu> s ostatnimi soubory, ktere plugin
  //potrebuje, ten presuneme do adresare pluginu
  s2:=GetPluginDir()+'\'+GetMyName();
  {$ifdef DEBUG_HELPER} LDH('Test dir: '+s2); {$endif}
  if(DirectoryExists(s2)) then DelTree(s2); //bez smazani se neprekopiruje nova adresare
  RenameFile(GetMyDir()+'\'+GetMyName(),s2);
  DelTree(GetMyDir());  //smazeme zdrojovy adresar
end;

function UninstallWork: String;
var s:string;
begin
{$ifdef DEBUG_HELPER} LDHInit(true); {$endif}
  {$ifdef DEBUG_HELPER} LDH('MyName='+GetMyName()); {$endif}
  {$ifdef DEBUG_HELPER} LDH('MyDir='+GetMyDir()); {$endif}
  {$ifdef DEBUG_HELPER} LDH('IniDir='+GetIniDir()); {$endif}
  {$ifdef DEBUG_HELPER} LDH('PluginDir='+GetPluginDir()); {$endif}

  Result:='';
  ShowMessage('CCCCCC odinstalovani pluginu');
  s:=GetIniDir()+'\'+GetMyName()+'.meta.ini';
  {$ifdef DEBUG_HELPER} LDH('Mazu '+s); {$endif}
  if(FileExists(s)) then DeleteFile(s);  //smazeme nase *.meta.ini
  s:=GetIniDir()+'\'+GetMyName()+'.ggi.pas';
  {$ifdef DEBUG_HELPER} LDH('Mazu '+s); {$endif}
  if(FileExists(s)) then DeleteFile(s);  //smazeme nas instalacni plugin
  s:=GetPluginDir()+'\'+GetMyName()+'.ggm.js';
  {$ifdef DEBUG_HELPER} LDH('Mazu '+s); {$endif}
  if(FileExists(s)) then DeleteFile(s);  //smazeme vlastni mapovy plugin
  s:=GetPluginDir()+'\'+GetMyName()+'.css';
  {$ifdef DEBUG_HELPER} LDH('Mazu '+s); {$endif}
  if(FileExists(s)) then DeleteFile(s);  //smazeme jeho css
  //smazat adresar s ostatnimi soubory pluginu
  s:=GetPluginDir()+'\'+GetMyName();
  if(DirectoryExists(s)) then DelTree(s);
end;
